<?xml version="1.0" encoding="UTF-8"?>

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<!-- Convert tagml to geni lexicon format -->
<xsl:output method="text"
            version="1.0"
            encoding="utf-8"
            indent="no"
            media-type="string"/>

<xsl:template match="tagml">
<xsl:text>%%
%% Geni Lexicon
%% This UTF-8 file was automatically generated by
%% a tagml->geni lexicon conversion script,
%% tagml2genilex.xsl
%% contact: kow@loria.fr lai@loria.fr
%%

</xsl:text>
  <xsl:apply-templates select="lexicalizationLib"/>

</xsl:template>

<!-- ***************** -->
<!-- LEXICALIZATIONLIB -->
<!-- ***************** -->
<xsl:template match="lexicalizationLib">
  <xsl:for-each select="lexicalization">
    <xsl:variable name="tree" select="tree/@copyof"/>
    <xsl:variable name="sym" select="family/tree/fs/f/sym/@value"/>

    <xsl:for-each select="anchor/lemmaref">
      <xsl:value-of select="@name"/>
      <xsl:text> </xsl:text>
      <xsl:if test="$tree"><xsl:value-of select="$tree"/></xsl:if>
      <xsl:if test="$sym">
        <xsl:value-of select="ancestor::tagml/treeLib/tree/fs/f/sym[@value=$sym]/../../../@id"/>
      </xsl:if>
      <xsl:text>()
</xsl:text>
    </xsl:for-each>
  </xsl:for-each>
</xsl:template>

</xsl:stylesheet>